;================================================
;	LUNAR LANDER
;	ver 1.00
;	for PC-G850 series
;	AASM 3.70
;	2006-10
;	by CHOI KYUN ikyuns@lily.freemail.ne.jpj
;================================================



	include	"MACRO.ASM"		;{}N
	include "DEF.ASM"		;e`

	org	0100h




Init:
	call	Cls			;ʏ
	call	Init_KEY		;L[
	call	Init_LCDC		;LCDC
	call	Init_BEEP		;BEEP

	call	Print_CREDIT		;ҕ\
	call	ClearFullScreen		;XN[

	call	Title			;^Cg\
	call	ClearFullScreen

	call	InitHiscore		;nCXRA
	call	Randomize		;



OverStart:
	call	InitScore		;XRA
	call	InitLevel		;x
ReStart:
	call	ClearFullScreen
	call	InitValue		;eϐ
	call	MakeField		;tB[h쐬
	call	InitStatus		;Xe[^Xʏ

	call	Ready



Main:
	{
		call	Inkey		;L[

		call	DrawBG		;n`̍

		call	MoveLander	;@ړ
		call	RotateLander	;@]
		call	DispLander	;@\

		call	CheckLandForm	;n`Ɠ蔻
		call	CheckLanding	;

		call	Pause		;|[Y
		call	ChangeSe	;ʉ̐؂芷
		call	DispScreen	;XN[\

		call	Clear		;NA
		call	GameOver	;Q[I[o[

		ld	hl,game_speed	;Q[Xs[h
		inc	(hl)

		in	a,(01fh)	;[BREAK]L[ŏI
		rlca
		jr	nc,continue
	}



Basic:
	call	Cls
	call	InfoVer_GAME		;o[W\
	call	InfoVer_LIB
	ret



;------------------------------------------------
;	^Cg\
;------------------------------------------------
Title:
	call	Print_LOGO
	call	DispScreen
	call	Print_SE
	{
		call	Inkey
		call	ChangeSe
		call	DispScreen
		{
			in	a,(01fh)
			rlca
			jr	nc,break
			pop	af		;PCA
			jp	Basic		;イ[
		}
		ld	a,(keyf)
		bit	KEY_SPC,a
		jr	z,continue
	}
	jp	Sound2
;	ret


	;^Cg\
Print_LOGO:
	ld	d,1
	ld	hl,Title_data
	{
		ld	e,24
		ld	bc,96
		call	PutBitmap
		add	hl,bc
		inc	d
		ld	a,d
		cp	7
		jr	nz,continue
	}
	ret



;------------------------------------------------
;	ϐ
;------------------------------------------------
InitValue:
	ld	hl,0
	ld	(lander_x),hl		;X=0
	ld	(lander_y),hl		;Y=0
	ld	(v_y),hl		;xY

	ld	l,DEF_VX		;xX
	ld	(v_x),hl

	xor	a
	ld	(lander_vec),a		;
	ld	(game_speed),a		;Q[Xs[hJE^
	ld	(booster_flg),a
	ld	(over_flg),a
	ret



	;x
InitLevel:
	xor	a
	ld	(stage),a

	inc	a
	ld	(level),a		;x

	ld	a,DEF_LAND_WIDTH	;n_
	ld	(point_width),a

	ld	a,MAX_ENERGY		;GlM[
	ld	(energy),a

	ld	a,DEF_ENERGY_X		;GlM[Q[WXW
	ld	(energy_x),a
	ret



;------------------------------------------------
;	Q[JnI
;------------------------------------------------
Ready:
	{
		call	Inkey
		call	DrawBG
		call	Print_PUSH
		call	Print_STAGE
		call	SelectStage
		call	ChangeSe
		call	DispScreen
		{
			in	a,(01fh)
			rlca
			jr	nc,break
			pop	af		;PCA
			jp	Basic		;イ[
		}
		ld	a,(keyf)
		bit	KEY_SPC,a
		jr	z,continue
	}
	call	Sound2
	ld	bc,400
	jp	Wait
;	ret



	;Xe[WI
SelectStage:
	ld	a,(keyf)
	bit	KEY_8,a
	ret	z

	ld	a,(stage)
	xor	1
	ld	(stage),a
	jp	Sound2



	;Xe[W\ MOON,JUPT
Print_STAGE:
	ld	hl,Font_MOON
	ld	de,0
	{
		ld	a,(stage)
		or	a
		jr	z,break
		ld	e,21
	}
	add	hl,de

	ld	de,1*256+0			;0,1
	ld	bc,21
	jp	PutBitmap



;------------------------------------------------
;	@]
;------------------------------------------------
RotateLander:
	ld	hl,lander_vec
	ld	a,(keyf)


_right:
	bit	KEY_6,a			;Eɉ]
	jr	z,_left

	inc	(hl)
	ld	a,3
	and	(hl)
	ld	(hl),a
	jp	Sound2


_left:
	bit	KEY_4,a			;ɉ]
	ret	z

	dec	(hl)
	ld	a,3
	and	(hl)
	ld	(hl),a
	jp	Sound2



;------------------------------------------------
;	D̈ړ
;------------------------------------------------
MoveLander:
	ld	a,(game_speed)		;Q[x
	and	0000_1111b
	ret	nz

	xor	a
	ld	(booster_flg),a

	call	Acceleration		;

	ld	hl,lander_vec
	ld	a,(key)

	bit	KEY_SPC,a		;GW_
	ret	z

	ld	a,(lander_y)
	cp	4			;ʂ͂ݏo瑀s\
	ret	c

	ld	a,(energy)		;GlM[؂ꂽ瑀s\
	or	a
	ret	z

	ld	a,1
	ld	(booster_flg),a

	call	MainBooster
	jp	DispEnergyGauge		;GlM[Q[W
;	ret



	;GW_
	;HL	
MainBooster:
	ld	a,(hl)
	ld	de,POWER
	{
		cp	L_UP
		jr	nz,break

		ld	hl,(v_y)
		or	a
		sbc	hl,de
		ld	(v_y),hl
		ret
	}
	{
		cp	L_RIGHT
		jr	nz,break

		ld	hl,(v_x)
		add	hl,de
		ld	(v_x),hl
		ret
	}
	{
		cp	L_DOWN
		jr	nz,break

		ld	hl,(v_y)
		add	hl,de
		ld	(v_y),hl
		ret
	}
	{
		ld	hl,(v_x)
		or	a
		sbc	hl,de
		ld	(v_x),hl
		ret
	}



	;D̉
Acceleration:
	ld	hl,(v_y)		;d
	ld	de,MOON_G
	{
		ld	a,(stage)
		or	a
		jr	z,break
		ld	de,JUPT_G
	}
	add	hl,de
	ld	(v_y),hl

	ld	hl,(lander_x)		;xX
	ld	de,(v_x)
	add	hl,de
	{
		bit	7,h		;0<=X<=96
		jr	z,break
		ld	hl,0
		jr	_next
	}
	{
		ld	a,h
		cp	96
		jr	c,break
		ld	hl,96*256+0
	}
_next:
	ld	(lander_x),hl

	ld	hl,(lander_y)		;xY
	ld	de,(v_y)
	add	hl,de
	{
		bit	7,h		;}CiXɂȂ
		jr	z,break
		ld	hl,0
		ld	(v_y),hl	;xZbg
	}
	ld	(lander_y),hl
	ret



;------------------------------------------------
;	GlM[Q[W̕\
;------------------------------------------------
DispEnergyGauge:
	ld	hl,energy
	dec	(hl)

	jp	Init_E_GAUGE
;	ret



;------------------------------------------------
;	̕\
;------------------------------------------------
DispBooster:
	ld	a,(booster_flg)
	or	a
	ret	z

	ld	hl,lander_x+1
	ld	e,(hl)
	inc	hl
	inc	hl
	ld	d,(hl)

	ld	hl,Chr_BOOST
	ld	a,(lander_vec)
	add	a,a
	add	a,a
	add	a,a
	ld	c,a
	ld	b,0
	add	hl,bc

	ld	a,(lander_vec)
	{
		cp	L_UP
		jr	nz,break

		ld	a,d
		add	a,6
		ld	d,a
		jp	PutChr
	}
	{
		cp	L_RIGHT
		jr	nz,break

		ld	a,e
		sub	3
		ret	c
		ld	e,a
		jp	PutChr
	}
	{
		cp	L_DOWN
		jr	nz,break

		ld	a,d
		sub	3
		ld	d,a
		jp	PutChr
	}
	{
		ld	a,e
		add	a,6
		ld	e,a
		jp	PutChr
	}



;------------------------------------------------
;	D̕\
;------------------------------------------------
DispLander:
	call	DispBooster

	ld	hl,Chr_LANDER
	ld	a,(lander_vec)
	add	a,a
	add	a,a
	add	a,a
	ld	e,a
	ld	d,0
	add	hl,de

	ld	a,(lander_x+1)
	ld	e,a
	ld	a,(lander_y+1)
	ld	d,a

	jp	PutChr



;------------------------------------------------
;	n`ƏՓ˔
;------------------------------------------------
CheckLandForm:
	ld	hl,Chr_LANDER
	ld	a,(lander_vec)
	add	a,a
	add	a,a
	add	a,a
	ld	e,a
	ld	d,0
	add	hl,de

	ld	a,(lander_x+1)
	add	a,144
	ld	e,a
	ld	a,(lander_y+1)
	ld	d,a

	call	GetPos
	ld	b,CHR_X_SIZE
	{
		ld	a,(de)		;LN^ǂݍ
		inc	de

		push	hl
		ld	l,a
		ld	h,0

		ld	a,ixl			;VtgJEg
		{
			or	a		;cp	0
			jr	z,break
			{
				add	hl,hl	;Vtg
				dec	a
				jr	nz,continue
			}
		}
		ld	a,l
		ld	c,h
		pop	hl

		and	(hl)		;
		jr	nz,break

		inc	h
		ld	a,c
		and	(hl)		;
		jr	nz,break

		dec	h
		inc	hl
		djnz	continue
		ret
	}
	ld	a,FLG_OVER
	ld	(over_flg),a
	ret



;------------------------------------------------
;	BG̍
;------------------------------------------------
DrawBG:
	ld	hl,ScreenBuf+144
	ld	de,ScreenBuf
	ld	bc,WIN_WIDTH
	ldir

	ld	hl,ScreenBuf+256+144
	ld	de,ScreenBuf+256
	ld	bc,WIN_WIDTH
	ldir

	ld	hl,ScreenBuf+256*2+144
	ld	de,ScreenBuf+256*2
	ld	bc,WIN_WIDTH
	ldir

	ld	hl,ScreenBuf+256*3+144
	ld	de,ScreenBuf+256*3
	ld	bc,WIN_WIDTH
	ldir

	ld	hl,ScreenBuf+256*4+144
	ld	de,ScreenBuf+256*4
	ld	bc,WIN_WIDTH
	ldir

	ld	hl,ScreenBuf+256*5+144
	ld	de,ScreenBuf+256*5
	ld	bc,WIN_WIDTH
	ldir

	ld	hl,ScreenBuf+256*6+144
	ld	de,ScreenBuf+256*6
	ld	bc,WIN_WIDTH
	ldir
	ret



;------------------------------------------------
;	tB[h̍쐬
;------------------------------------------------
MakeField:
	call	SetPoint		;n_̍쐬
	call	DrawPoint		;n_`
	call	SetDebris		;fu̍쐬
	call	DrawLine		;n`̕`
	ret



;------------------------------------------------
;	n_̍쐬
;------------------------------------------------
SetPoint:
	ld	hl,point_width		;-4
	{
		ld	a,(level)
		cp	9		;ő僌x
		jr	z,break
		dec	(hl)
		dec	(hl)
		dec	(hl)
		dec	(hl)
	}
	ld	b,(hl)
	ld	a,WIN_WIDTH
	sub	b
	ld	b,a
	{
		call	Rnd
		and	127
		cp	b
		jr	nc,continue	;0..105-W
	}
	dec	hl
	ld	(hl),a			;XW
	ret



;------------------------------------------------
;	fu
;------------------------------------------------
SetDebris:
	call	Rnd
	and	3			;0..3
	ld	ixl,a

	ld	a,(point_x)
	ld	ixh,a
	{
		ld	a,ixl
		or	a
		ret	z

		ld	a,(point_width)
		ld	b,a
		{
			call	Rnd
			and	7
			add	a,a
			add	a,a
			cp	b
			jr	nc,continue
		}
		add	a,ixh
		add	a,144+6

		ld	e,a			;X
		call	Rnd
		and	3

		inc	a
		inc	a			;2..5
		ld	d,a			;Y

		ld	hl,Chr_DEBRI
		ld	bc,3
		call	PutBitmap

		dec	ixl
		jr	continue
	}
	ret



;------------------------------------------------
;	n_`
;------------------------------------------------
DrawPoint:
	ld	hl,ScreenBuf+256*6
	ld	a,(point_x)
	add	a,144
	ld	e,a
	ld	d,0
	add	hl,de

	ld	a,(point_width)
	ld	b,a
	{
		ld	(hl),1000_0000b		;C
		inc	hl
		djnz	continue
	}
	ret



;------------------------------------------------
;	n`̕`
;------------------------------------------------
DrawLine:
	;̗Ő
	ld	a,(point_x)	;n_@X,6
	add	a,144
	ld	e,a
	ld	d,6
	{
		ld	a,e
		cp	144
		jr	c,break

		ld	hl,Land_data	;n`
		call	Rnd
		and	3
		ld	ixl,a

		add	a,a
		add	a,a
		add	a,a
		add	a,a		;~16
		ld	c,a
		ld	b,0
		add	hl,bc

		ld	b,ixl		;2,4,8,16
		inc	b
		ld	a,1
		{
			add	a,a
			djnz	continue
		}
		ld	c,a
		ld	a,e
		sub	c
		ld	e,a
		call	PutBitmap	;`

		dec	d		;Y-1
		ld	a,d
		cp	1
		jr	nz,continue
	}
	;
	{
		ld	a,e
		sub	144
		jr	c,break
		jr	z,break
		{
			srl	a
			ld	b,a
			jr	nc,break
			inc	b
		}
		ld	hl,ScreenBuf+256+144
		{
			or	a		;0ȂXLbv
			jr	z,break

			ld	(hl),64
			inc	hl
			djnz	continue
		}
		ld	b,a
		{
			or	a
			jr	nz,break
			inc	b
		}
		{
			ld	(hl),128
			inc	hl
			djnz	continue
		}
	}
	;E̗Ő
	ld	a,(point_x)	;n_@X+W,6
	ld	b,a
	ld	a,(point_width)
	add	a,b
	add	a,144
	ld	e,a
	ld	d,6
	{
		ld	a,e
		cp	143
		jr	c,break
		cp	144+WIN_WIDTH
		jr	nc,break

		ld	hl,Land_data+16*4	;n`
		call	Rnd
		and	3
		ld	ixl,a

		add	a,a
		add	a,a
		add	a,a
		add	a,a		;~16
		ld	c,a
		ld	b,0
		add	hl,bc

		ld	b,ixl		;2,4,8,16
		inc	b
		ld	a,1
		{
			add	a,a
			djnz	continue
		}
		ld	c,a
		call	PutBitmap	;`

		add	a,e
		ld	e,a

		dec	d		;Y-1
		ld	a,d
		cp	1
		jr	nz,continue
	}
	;
	{
		ld	a,e
		cp	143
		jr	c,break

		sub	144+WIN_WIDTH
		jr	nc,break
		jr	z,break

		neg
		{
			srl	a
			ld	b,a
			jr	nc,break
			inc	b
		}
		ld	hl,ScreenBuf+256+144+WIN_WIDTH-1
		{
			or	a
			jr	z,break

			ld	(hl),64
			dec	hl
			djnz	continue
		}
		ld	b,a
		{
			or	a
			jr	nz,break
			inc	b
		}
		{
			ld	(hl),128
			dec	hl
			djnz	continue
		}
	}
	ret



;------------------------------------------------
;	ʉ̐؂芷
;------------------------------------------------
ChangeSe:
	ld	a,(keyf)
	bit	KEY_CLS,a
	ret	z

	ld	a,(sound)
	xor	1
	ld	(sound),a

	ld	b,a
	add	a,a
	add	a,b
	rrca
	rrca
	ld	(_beep+1),a		;00H or 0C0H
	jp	Print_SE



;------------------------------------------------
;	Xe[^Xʏ
;------------------------------------------------
InitStatus:
	call	ClearStatus		;Xe[^Ẍ̃NA

	call	Init_E_GAUGE		;GlM[Q[W

	call	Print_HI		;nCXRA
	call	Print_SC		;XRA
	call	Print_LV		;x
	call	Print_SE		;ACR
	call	Print_LINE		;؂

	call	DispHiScore		;nCXRA\
	call	DispScore		;XRA\
	call	DispLv			;x\
	ret


	;GlM[Q[W
Init_E_GAUGE:
	ld	hl,ScreenBuf+256*6+108
	ld	b,26
	{
		ld	(hl),07eh	;
		inc	hl
		djnz	continue
	}
	dec	hl
	dec	hl

	ld	a,(energy)
	ld	b,a
	ld	a,MAX_ENERGY
	sub	b

	srl	a			;/2
	ret	z

	ld	b,a
	{
		ld	(hl),042h	;
		dec	hl
		djnz	continue
	}
	ret


Print_SE:
	ld	a,(sound)
	add	a,a
	add	a,a
	add	a,a
	ld	e,a
	ld	d,0
	ld	hl,Icon_SE
	add	hl,de

	ld	de,6*256+137		;137,6
	ld	bc,7
	jp	PutBitmap


Print_HI:
	ld	hl,Font_HI		;HI-SC
	ld	de,1*256+108		;108,1
	ld	bc,35
	jp	PutBitmap


Print_SC:
	ld	hl,Font_SC		;SCORE
	inc	d
	inc	d			;108,3
;	ld	bc,29
	jp	PutBitMap


Print_LV:
	ld	hl,Font_LV		;LV
	inc	d
	inc	d			;108,5
	ld	bc,11
	jp	PutBitMap


Print_LINE
	ld	hl,ScreenBuf+256+104
	ld	b,6
	{
		ld	(hl),0ffh
		inc	h
		djnz	continue
	}
	ret



;------------------------------------------------
;	`FbN
;------------------------------------------------
CheckLanding:
	ld	a,(lander_y+1)
	cp	49
	ret	nz

	ld	a,(lander_vec)		;
	or	a
	ret	nz

	;a+b+1
	ld	hl,point_width
	ld	a,(hl)

	add	a,6
	ld	b,a
	;mx-ex+a
	dec	hl
	ld	a,(lander_x+1)
	sub	(hl)
	add	a,6

	;mx-ex+a<a+b+1
	cp	b
	ret	nc

	ld	hl,(v_x)		;Xx
	{
		bit	7,h
		jr	z,break

		ld	a,l
		cpl
		ld	l,a
		ld	a,h
		cpl
		ld	h,a
		inc	hl		;NEG HL
	}
	ld	de,50			;-50..50
	or	a
	sbc	hl,de
	ret	nc

	ld	hl,(v_y)		;Yx
	{
		bit	7,h
		jr	z,break

		ld	a,l
		cpl
		ld	l,a
		ld	a,h
		cpl
		ld	h,a
		inc	hl		;NEG HL
	}
	ld	c,l
	ld	b,h
	ld	de,50			;-50..50
	or	a
	sbc	hl,de
	ret	nc

	ld	a,FLG_CLEAR		;HARD LANDING
	ld	(over_flg),a

	ld	l,c
	ld	h,b
	ld	de,20			;-20..20
	or	a
	sbc	hl,de
	ret	nc

	or	FLG_GOOD		;GOOD LANDING
	ld	(over_flg),a
	ret



;------------------------------------------------
;	Q[NA
;------------------------------------------------
Clear:
	ld	a,(over_flg)
	bit	0,a
	ret	z

	call	Sound4
	ld	bc,600
	call	Wait

	call	Print_CLEAR
	call	Print_LANDING
	call	Print_PUSH
	{
		bit	7,a			;GOOD LANDING
		jr	z,break
		call	Print_GOOD
	}
	call	ChargeEnergy			;GlM[
	call	AddScore			;XRAZ
	{
		call	Inkey
		call	ChangeSe
		call	DispScreen
		{
			in	a,(01fh)
			rlca
			jr	nc,break
			pop	af		;PCA
			jp	Basic		;イ[
		}
		ld	a,(keyf)
		bit	KEY_SPC,a
		jr	z,continue
	}
	{
		ld	hl,level		;xAbv
		ld	a,(hl)
		cp	9
		jr	z,break
		inc	(hl)
	}
	call	Sound2
	pop	af
	jp	ReStart



Print_CLEAR:
	ld	hl,Font_CLEAR		;CLEAR
	ld	de,2*256+37		;37,2
	ld	bc,30
	jp	PutBitmap


Print_LANDING:
	ld	hl,Font_HARD		;HARD LANDING
	ld	de,3*256+25		;25,3
	ld	bc,21+33
	jp	PutBitmap


Print_GOOD:
	ld	hl,Font_GOOD		;GOOD
	ld	de,3*256+25		;25,3
	ld	bc,21
	jp	PutBitmap



;------------------------------------------------
;	GlM[
;------------------------------------------------
ChargeEnergy:
	{
		bit	7,a		;GOOD LANDINGőS
		jr	z,break
		ld	a,MAX_ENERGY
		ld	(energy),a
		jp	Init_E_GAUGE
	}
	ld	a,(energy)
	cp	2*10		;ȉȂ
	ret	nc
	{
		ld	b,2*5		;5|Cg
		add	a,b
		cp	2*24
		jr	c,break
		ld	a,2*24
	}
	ld	(energy),a

	jp	Init_E_GAUGE



;------------------------------------------------
;	XRAZ
;------------------------------------------------
AddScore:
	ld	hl,0
	ld	(work),hl
	ld	(work+1),hl
	ld	(work+2),hl

	ld	a,(level)
	ld	b,a
	ld	hl,over_flg
	ld	c,(hl)
	{
		ld	a,01h		;100_~x
		{
			bit	7,c
			jr	z,break
			rlca		;200_~x
		}
		ld	hl,work+1

		add	a,(hl)
		daa
		ld	(hl),a
		dec	hl

		xor	a
		adc	a,(hl)
		daa
		ld	(hl),a

		djnz	continue
	}
	ld	hl,work
	ld	de,4*256+37		;37,4
	call	PutBCD3			;6\

	ld	hl,score+1		;addp (score),(work)
	ld	a,(work+1)
	add	a,(hl)
	daa
	ld	(hl),a

	dec	hl
	xor	a
	adc	a,(hl)
	daa
	ld	(hl),a
	ret



;------------------------------------------------
;	Q[I[o[
;------------------------------------------------
GameOver:
	ld	a,(over_flg)
	bit	1,a
	ret	z

	ld	bc,600
	call	Wait

	call	DrawBG
	call	DispCrash
	call	DispScreen
	call	Sound3

	ld	bc,600
	call	Wait

	call	Print_OVER
	call	Print_PUSH
	{
		call	Inkey
		call	ChangeSe
		call	DispScreen
		{
			in	a,(01fh)
			rlca
			jr	nc,break
			pop	af		;PCA
			jp	Basic		;イ[
		}
		ld	a,(keyf)
		bit	KEY_SPC,a
		jr	z,continue
	}
	call	CmpHiScore			;nCXRAL^
	call	Sound2
	pop	af
	jp	OverStart



	;\
DispCrash:
	ld	hl,Chr_CRASH
	ld	a,(lander_x+1)
	ld	e,a
	ld	a,(lander_y+1)
	sub	2
	ld	d,a
	jp	PutChr



Print_OVER:
	ld	hl,Font_OVER		;GAMEOVER
	ld	de,3*256+27		;27,3
	ld	bc,49
	jp	PutBitmap



Print_PUSH:
	ld	hl,Font_PUSH		;PUSH <SPC> TO START!!
	ld	de,6*256+36		;36,6
	ld	bc,68
	jp	PutBitmap



	;nCXRAL^
CmpHiScore
	ld	hl,hiscore+1
	ld	a,(score+1)
	sub	(hl)
	daa

	dec	hl
	ld	a,(score)
	sbc	(hl)
	daa

	ret	c

	ld	a,(score)
	ld	(hiscore),a
	ld	a,(score+1)
	ld	(hiscore+1),a
	ret



;------------------------------------------------
;	|[Y
;------------------------------------------------
Pause:
	ld	a,(keyf)
	bit	KEY_SHIFT,a
	ret	z
	call	Sound2
	call	Print_PAUSE
	{
		call	Inkey
		call	ChangeSe
		call	DispScreen
		{
			in	a,(01fh)
			rlca
			jr	nc,break
			pop	af		;PCA
			jp	Basic		;イ[
		}
		ld	a,(keyf)
		bit	KEY_SHIFT,a
		jr	z,continue
	}
	call	Sound2
	ret



Print_PAUSE:
	ld	hl,Font_PAUSE
	ld	de,6*256+0			;0,6
	ld	bc,20
	jp	PutBitmap



;------------------------------------------------
;	XN[\
;------------------------------------------------
DispScreen:
	ld	hl,ScreenBuf+256+SCREEN_BLANK
	jp	Send_LCDC
;	ret



;------------------------------------------------
;	EBhẼNA
;------------------------------------------------
ClearWindow:
	ld	hl,ScreenBuf+256+SCREEN_BLANK
	jp	ClearScreen
;	ret



;------------------------------------------------
;	Xe[^Ẍ̃NA
;------------------------------------------------
ClearStatus:
	ld	hl,144-WIN_WIDTH-1
	ld	(__win_width+1),hl

	ld	hl,ScreenBuf+256+WIN_WIDTH
	call	ClearScreen

	ld	hl,WIN_WIDTH-1
	ld	(__win_WIDTH+1),hl
	ret



;------------------------------------------------
;	ʉ
;------------------------------------------------

	;
Sound1:
	push_all
	ld	hl,500
	ld	de,6
	call	Beep
	ld	hl,600
	ld	de,6
	call	Beep
	pop_all
	ret


	;]
Sound2:
	push_all
	ld	hl,480
	ld	de,3
	call	Beep
	ld	hl,420
	ld	de,3
	call	Beep
	pop_all
	ret


	;Q[I[o[
Sound3:
	push_all
	ld	hl,800
	ld	de,20
	call	Beep
	ld	hl,1200
	ld	de,40
	call	Beep
	pop_all
	ret


	;NA
Sound4:
	push_all
	ld	hl,440
	ld	de,20
	call	Beep
	ld	hl,360
	ld	de,40
	call	Beep
	pop_all
	ret



;------------------------------------------------
;	XRA
;------------------------------------------------
InitScore:
	ld	hl,0
	ld	(score),hl	;_
	ld	(score+1),hl
	ret


InitHiScore:
	ld	hl,0
	ld	(hiscore),hl
	ld	(hiscore+1),hl
	ret



;------------------------------------------------
;	XRA\
;------------------------------------------------
DispScore:
	ld	hl,score
	ld	de,4*256+114		;113,4
	jp	PutBCD3			;6\


DispHiScore:
	ld	hl,hiscore
	ld	de,2*256+114		;113,2
	jp	PutBCD3


DispLv:
	ld	hl,level
	ld	de,5*256+134		;133,5
	jp	PutBCD			;2\



;------------------------------------------------
;	o[W\
;------------------------------------------------
InfoVer_GAME:
	ld	hl,_g_ver
	ld	de,0			;X=0,Y=0
	ld	b,_g_end-_g_ver
	call	SYS_PUT_STRING
	ret


_g_ver:
	db	'LUNAR LANDER 1.00'
_g_end:



	include	"LIB.ASM"		;Cu
	include "DATA.ASM"		;f[^
	include	"WORK.ASM"		;[NGA



	end
	